#pragma once

#include <ffgl/PluginBase.h>
#include <ffgl/ParamFloat.h>
#include <ffglex/ScreenQuad.h>
#include <ffglex/Shader.h>

// 2019-07-20 ffgl@subpixels.com
// - Replaced "Ptr" (shared_ptr) parameter members with regular pointers

// 2019-10-23 ffgl@subpixels.com
// - Introduce namespace ffgl::plugin::effect

namespace ffgl
{
namespace plugin
{
namespace effect
{

class Gradient : public PluginBase
{
public:
	Gradient();

	// PluginManager overrides
	FFResult InitGL( const ViewportStruct* vp ) override;
	FFResult ProcessOpenGL( ProcessOpenGLStruct* pGL ) override;
	FFResult DeinitGL() override;

private:
	ParamFloat* hue1;
	ParamFloat* hue2;
	ParamFloat* saturation;
	ParamFloat* brightness;

	GLint rgb1Location;
	GLint rgb2Location;

	ffglex::Shader shader;   //!< Utility to help us compile and link some shaders into a program.
	ffglex::ScreenQuad quad; //!< Utility to help us render a full screen quad.
};

}// namespace effect
}// namespace freeframe
}// namespace spxl
